MLfitToGrowthRate.aOFl<-function(Y,norm.const,Z,lambda,a.vec,print.level=0){
nu<-norm.const
a<-a.vec
dlambda<-lambda-mean(lambda)
n.tran<-dim(Y)[1]
LLA<-rep(0,n.tran)
pValRegress<-LLA
EstA<-matrix(0,nrow=n.tran,ncol=2)
BetaRegress<-EstA
CodeA<-LLA
LL0<-LLA
Est0<-LLA
Code0<-CodeA
for(km in 1:n.tran){
	z<-Z[km,]
	zz<-z; 
	zz[z==0]<-1/nu[z==0] #comes from replacing a count (Y) of zero with integer 1
 	log.z<-log(zz)
	lm.log<-lm(log.z~dlambda) #Gives initial estimate of the coefficients in the model in which expression, z, depends
	                                            #exponentially on the growth rate
	#sum.lm.log<-summary.lm(lm.log)
	pValRegress[km]<-summary.lm(lm.log)$coefficients["dlambda","Pr(>|t|)"]
	BetaRegress[km,]<-summary.lm(lm.log)$coefficients[,"Estimate"]
	
	x0.HA<-lm.log$coefficients

 	nlm.outA <- nlm(LLlambdaOFlEXP,p=x0.HA,y=Y[km,],nu=nu,
                    a.vec=a.vec,lambda=lambda,
                    H="A",print.level=print.level,
	                 fscale=100,iterlim=100,steptol=1e-6,
	                 gradtol=1e-6)

	  LLA[km] <- -nlm.outA$minimum
	 EstA[km,] <- nlm.outA$estimate
	CodeA[km] <-  nlm.outA$code
	
	x0.H0<-log(mean(z))
	nlm.out0<-nlm(LLlambdaOFlEXP,p=x0.H0,y=Y[km,],nu=nu,
	a.vec=a.vec,lambda=lambda,
	H="0",print.level=print.level,
	fscale=100,iterlim=100,steptol=1e-6, gradtol=1e-6)
	
	  LL0[km] <- -nlm.out0$minimum
	 Est0[km] <-  nlm.out0$estimate
	Code0[km] <-  nlm.out0$code
}
  Chi.sq <- 2*( LLA - LL0 )
	pValML <- pchisq(q=Chi.sq,df=1,lower.tail=FALSE)
	Code<-data.frame(H0=Code0,HA=CodeA)
	
	names(LL0)<-rownames(Y); names(LLA)<-rownames(Y)
	names(Est0)<-rownames(Y); rownames(EstA)=rownames(Y)
	rownames(Code)<-rownames(Y); names(Chi.sq)<-rownames(Y)
	names(pValML)<-rownames(Y)
	ML.out<-list(LL0=LL0, LLA=LLA, Est0=Est0, EstA=EstA,
	 Code=Code, Chi.sq=Chi.sq, pValML=pValML, BetaRegress=BetaRegress,
	 pValRegress=pValRegress)
	 
	ML.out
	}
